Subject: Re: [PATCH net-next] net: mark tulip obsolete

From: Jakub Kicinski <[email-masked]>
Date: Tue, 26 Apr 2022 14:31:34 -0700

On Tue, 26 Apr 2022 22:53:00 +0200 Helge Deller wrote:
> >> That intention is ok, but "obsolete" means it's not used any more,
> >> and that's not true.  
> >
> > Hi Helge! Which incarnation of tulip do you need for PA-RISC, exactly?  
> 
> For parisc I have:
> 
> CONFIG_NET_TULIP=y
> # CONFIG_DE2104X is not set
> CONFIG_TULIP=y
> # CONFIG_TULIP_MWI is not set
> # CONFIG_TULIP_MMIO is not set
> # CONFIG_TULIP_NAPI is not set
> # CONFIG_DE4X5 is not set
> # CONFIG_WINBOND_840 is not set
> # CONFIG_DM9102 is not set
> # CONFIG_ULI526X is not set
> # CONFIG_PCMCIA_XIRCOM is not set
> # CONFIG_NET_VENDOR_DLINK is not set
> # CONFIG_NET_VENDOR_EMULEX is not set
> 
> So not the DE4X5.
> 
> > I'd like to try to remove DE4X5, if that's not the one you need
> > (getting rid of virt_to_bus()-using drivers).  
> 
> I've CC'ed the linux-alpha mailing list, as the DE4X5 driver might be
> needed there, so removing it completely might not be the best idea.
> 
> But since you want to remove virt_to_bus()....
> It seems this virt_to_bus() call is used for really old x86 machines/cards,
> which probably aren't supported any longer.
> 
> See drivers/net/ethernet/dec/tulip/de4x5.c:
> ...
> #if !defined(__alpha__) && !defined(__powerpc__) && !defined(CONFIG_SPARC) && !defined(DE4X5_DO_MEMCPY)
> ...
>     tmp = virt_to_bus(p->data);
> ...
> 
> Maybe you could simply remove the part inside #if...#else
> and insert a pr_err() instead (and return NULL)?

Ah, good find, thanks for taking a look! I'll look into dropping just
sections of the code.